Index: CMT/v1r25-branch/source/cmt_parser.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_parser.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_parser.cxx	(revision 664)
@@ -3,4 +3,5 @@
 // arnault@lal.in2p3.fr
 // Modified by garonne@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
@@ -10,4 +11,5 @@
 #include <string.h>
 #include <ctype.h>
+#include <errno.h>
 
 //----------------------------------------------------------
@@ -50,8 +52,10 @@
 }
 
+//----------------------------------------------------------
 CmtContext::~CmtContext ()
 {
 }
 
+//----------------------------------------------------------
 void CmtContext::clear ()
 {
@@ -59,10 +63,12 @@
   m_build_nmake    = false;
   m_cmt_config     = "";
-  //m_cmt_path.clear ();
-  //m_cmt_path_pwds.clear ();
-  //m_cmt_path_sources.clear ();
   m_cmt_root       = "";
+  m_cmt_home       = "";
+  m_cmt_user_context = "";
+  m_cmt_site       = "";
   m_cmt_version    = "";
   m_use_cmt        = true;
+  m_use_projects   = true;
+
   m_current_dir     = "";
   m_current_file_path = "";
@@ -74,13 +80,24 @@
   m_current_offset  = "";
 
-  m_current_access   = DeveloperMode;
+  m_current_access  = UserMode;
+  m_current_style   = cmt_style;
+  m_current_structuring_style = default_structuring_style;
 
   m_current_tag      = "";
   m_current_target   = "";
   m_current_version  = "";
+
+  //  m_extra_tags       = "";
+  m_extra_tags.clear ();
+  m_tags.clear ();
+  m_tags_add.clear ();
+  m_tags_remove.clear ();
+
+  m_configure_error  = "";
+
+  m_debug = (::getenv ("CMTDEBUG") != 0) ? true : false;
+
   m_default_path     = "";
-
-  //m_quiet            = false;
-
+  m_quiet            = false;
   m_disable_warnings = false;
   m_warnings         = false;
@@ -91,13 +108,38 @@
 
   m_standard_macros_done = false;
-  m_current_access = UserMode;
-  m_current_style = cmt_style;
-  m_current_structuring_style = default_structuring_style;
   m_all_sets_done = false;
+
   m_autoconfigure_cmtpath = false;
-  m_debug = false;
-  if (getenv ("CMTDEBUG") != 0) m_debug = true;
-}
-
+
+  m_env_access = true;
+  m_print_mode = Csh;
+  m_strip_path = false;
+}
+//----------------------------------------------------------
+
+int CmtContext::initialize ()
+{
+  int errors (0);
+
+  cmt_string tags = CmtSystem::getenv ("CMTEXTRATAGS");
+  CmtSystem::cmt_string_vector words;
+  CmtSystem::split (tags, " \t,", words);
+  for (int i = 0; i < words.size (); i++)
+    {
+      bool has (false);
+      for (int j = 0; j < m_extra_tags.size (); j++)
+	{
+	  if (m_extra_tags[j] == words[i])
+	    {
+	      has = true;
+	      break;
+	    }
+	}
+      if (!has)
+	m_extra_tags.push_back (words[i]);
+    }
+
+  return - errors;
+}
 //----------------------------------------------------------
 
@@ -357,4 +399,12 @@
 
 
+//----------------------------------------------------------
+//
+//   The static Cmt member
+//
+//----------------------------------------------------------
+
+CmtContext& Cmt::m_cmt_context = Me;
+//CmtContext * Cmt::m_cmt_context = &Me;
 
 //----------------------------------------------------------
@@ -462,9 +512,10 @@
 
 //----------------------------------------------------------
+/*
 bool Cmt::build_nmake ()
 {
   return (Me.m_build_nmake);
 }
-
+*/
 //----------------------------------------------------------
 void Cmt::build_OS9_makefile (const cmt_string& target)
@@ -497,6 +548,6 @@
 void Cmt::clear ()
 {
-  Me.m_quiet = false;
   Me.clear ();
+  //Me.m_quiet = false;
 
   Database::clear ();
@@ -507,4 +558,54 @@
 
 //----------------------------------------------------------
+namespace {
+
+bool parse_cmt_flags (const cmt_string& file_name, CmtContext& cmt)
+{
+  cmt_string Flags (Cmt::get_cmt_flags (file_name));
+  if (CmtError::get_last_error_code () == CmtError::file_access_error)
+    return false;
+  if (Flags.size () == 0)
+    return true;
+
+  cmt_string CmtFlags (Cmt::get_cmt_flags ());
+  if (CmtFlags.size () != 0)
+    Flags += " " + CmtFlags;
+
+  CmtSystem::cmt_string_vector flags;
+  CmtSystem::split (Flags, " \t", flags);
+  for (int i = 0; i < flags.size (); i++)
+    {
+      if (flags[i] == "-without_cmt" &&
+	  cmt.m_use_cmt)
+	cmt.m_use_cmt = false;
+      else if (flags[i] == "-with_cmt" &&
+	       !cmt.m_use_cmt)
+	cmt.m_use_cmt = true;
+      else if (flags[i] == "-without_projects" &&
+	       cmt.m_use_projects)
+	cmt.m_use_projects = false;
+      else if (flags[i] == "-with_projects" &&
+	       !cmt.m_use_projects)
+	cmt.m_use_projects = true;
+      else if (flags[i] == "-no_strip_path" &&
+	       cmt.m_strip_path)
+	{
+	  cmt.m_strip_path = false;
+	  Symbol::set_strip_path (false);
+	}
+      else if (flags[i] == "-strip_path" &&
+	       !cmt.m_strip_path)
+	{
+	  cmt.m_strip_path = true;
+	  Symbol::set_strip_path (true);
+	}
+    }
+
+  return true;
+}
+
+}
+
+//----------------------------------------------------------
 //void Cmt::configure ()
 void Cmt::configure (const ArgParser& ap)
@@ -515,5 +616,5 @@
   if (configured) return;
 
-  Me.clear ();
+  //  Me.clear ();
 
   log << "configure_cmt_message" << log_endl;
@@ -523,4 +624,7 @@
   log << "configure_default_path" << log_endl;
   configure_default_path ();
+
+  log << "restore_all_tags" << log_endl;
+  restore_all_tags (0);
   log << "configure_version_tag" << log_endl;
   configure_version_tag ();
@@ -533,4 +637,58 @@
   log << "configure_site_tag" << log_endl;
   configure_site_tag (0);
+
+  cmt_string requirements;
+
+  if (Me.m_current_package.size () != 0 &&
+      Me.m_current_package != "cmt_standalone")
+    {
+      // we have a package name (not "cmt_standalone")
+      Use& use = Use::current();
+      use.set (Me.m_current_package, 
+	       Me.m_current_version, 
+	       Me.m_current_path);
+      if (CmtSystem::absolute_path (Me.m_current_path))
+	{
+	  if (!use.move_to ())
+	    {
+	      CmtError::set (CmtError::package_not_found, use.get_info ());
+	      return;
+	    }
+	}
+      else
+	{
+	  if (!use.move_to ("", true))
+	    {
+	      // will try again later from CMTPATH entries
+	    }
+	}
+
+      if (use.located ())
+	{
+	  // parse additional options
+	  parse_cmt_flags ("requirements", m_cmt_context);
+	}
+    }
+  else
+    {
+      if (Me.m_current_path.size () != 0 &&
+	  !CmtSystem::cd (Me.m_current_path))
+	{
+	  CmtError::set (CmtError::path_not_found, Me.m_current_path);
+	  return;
+	}
+
+      configure_current_dir ();
+      configure_current_structuring_style (ap);
+      cmt_string current_package_saved (Me.m_current_package);
+      requirements = configure_current_package ();
+      Me.m_current_package = current_package_saved;
+      if (requirements.size () != 0)
+	{
+	  // parse additional options
+	  parse_cmt_flags (requirements, m_cmt_context);
+	}
+    }
+
   log << "configure_current_dir" << log_endl;
   configure_current_dir ();
@@ -540,5 +698,4 @@
   //  log << "configure_current_dir" << log_endl;
 
-
   bool save_quiet = Me.m_quiet;
   Me.m_quiet = true;
@@ -546,5 +703,5 @@
   Me.m_autoconfigure_cmtpath = true;
   configure_cmt_path (0);
-  Me.m_autoconfigure_cmtpath = false;
+  //  Me.m_autoconfigure_cmtpath = false;
 
   Me.m_quiet = save_quiet;
@@ -553,4 +710,39 @@
 
   guess_current_project ();
+
+  if (Me.m_current_package.size () != 0 &&
+      Me.m_current_package != "cmt_standalone")
+    {
+      Use& use = Use::current();
+      if (!use.located ())
+	{
+	  if (!use.move_to ())
+	    {
+	      CmtError::set (CmtError::package_not_found, use.get_info ());
+	      return;
+	    }
+	  else
+	    {
+	      use.get_full_path (Me.m_current_dir);
+	      switch (use.style)
+		{
+		case cmt_style:
+		  Me.m_current_dir += CmtSystem::file_separator ();
+		  Me.m_current_dir += "cmt";
+		  break;
+		case mgr_style:
+		  Me.m_current_dir += CmtSystem::file_separator ();
+		  Me.m_current_dir += "mgr";
+		  break;
+		default:
+		  break;
+		}
+	      Me.m_current_file_path = Me.m_current_dir;
+
+	      Project::order_all ();
+	      Cmt::guess_current_project ();
+	    }
+	}
+    }
 
   log << "configure_current_structuring_style" << log_endl;
@@ -558,19 +750,32 @@
   configure_current_structuring_style (ap);
 
+//   if (requirements.size () == 0)
+//     {
   log << "configure_current_package" << log_endl;
   configure_current_package ();
+//     }
 
   Use& use = Use::current();
-
-  use.set (Me.m_current_package,
-           Me.m_current_version,
-           Me.m_current_path,
-           "",
-           "");
-
-  use.style = Me.m_current_style;
-  use.structuring_style = Me.m_current_structuring_style;
-
-  use.change_path (Me.m_current_path);
+  if (!use.located ())
+    {
+      use.set (Me.m_current_package,
+	       Me.m_current_version,
+	       Me.m_current_path);
+      use.style = Me.m_current_style;
+
+      if (use.style != none_style)
+	{
+	  use.structuring_style = Me.m_current_structuring_style;
+	  use.change_path (Me.m_current_path, Project::get_current ());
+	}
+      else
+	{
+	  use.real_path = Me.m_current_path;
+	}
+    }
+  else if (const Project * p = Project::get_current ())
+    {
+      use.set_project (p);
+    }
 
   if (CmtError::has_pending_error ()) 
@@ -584,4 +789,6 @@
 {
   if (!Me.m_autoconfigure_cmtpath) return;
+
+  if (!m_cmt_context.m_use_projects) return;
 
   cmt_string s;
@@ -621,5 +828,6 @@
 {
   Use& current_use = Use::current ();
-
+  current_use.get_cmtpath_and_offset (Me.m_current_cmtpath, Me.m_current_offset);
+  /*
   Me.m_current_cmtpath = "";
   Me.m_current_offset = "";
@@ -633,5 +841,5 @@
 
       Me.m_current_offset = current_use.path;
-
+  */
       /**
 	 try to remove this current CMTPATH entry from path.  This
@@ -639,5 +847,5 @@
 	 absolute path.
       */
-      
+  /*      
       Me.m_current_offset.replace (Me.m_current_cmtpath, empty_string);
       if (Me.m_current_offset[0] == CmtSystem::file_separator ())
@@ -648,4 +856,5 @@
 	}
     }
+  */
 }
 
@@ -731,4 +940,6 @@
 void Cmt::configure_current_dir ()
 {
+  if (Me.m_current_dir.size () != 0) return;
+
   cmt_string file_name;
 
@@ -788,9 +999,10 @@
   Me.m_current_file_path = mount_filter.get_current_dir ();
 
-  cmt_string t = Me.m_current_file_path;
-}
-
-//----------------------------------------------------------
-void Cmt::configure_current_package ()
+  //  cmt_string t = Me.m_current_file_path;
+}
+
+//----------------------------------------------------------
+cmt_string Cmt::configure_current_package ()
+//void Cmt::configure_current_package ()
 {
   /*
@@ -800,4 +1012,30 @@
     standard directory tree (i.e. <package>/<version>/cmt or mgr)
   */
+  Use& use = Use::current();
+  if (use.located ())
+    {
+      Me.m_current_style = use.style;
+      build_prefix (Me.m_current_package, Me.m_current_prefix);
+      build_config (Me.m_current_prefix, Me.m_current_config);
+
+      cmt_string req;
+      use.get_full_path (req);
+      switch (use.style)
+	{
+	case cmt_style:
+	  req += CmtSystem::file_separator ();
+	  req += "cmt";
+	  break;
+	case mgr_style:
+	  req += CmtSystem::file_separator ();
+	  req += "mgr";
+	  break;
+	default:
+	  break;
+	}
+      req += CmtSystem::file_separator ();
+      req += "requirements";
+      return req;
+    }
 
   cmt_string req = "..";
@@ -813,5 +1051,6 @@
   else
     {
-      cmt_string req = "..";
+      req = "..";
+      //      cmt_string req = "..";
       req += CmtSystem::file_separator ();
       req += "mgr";
@@ -827,4 +1066,9 @@
 	  // This package is probably a standalone one
 	  Me.m_current_style = none_style;
+	  req = "requirements";
+	  if (!CmtSystem::test_file (req))
+	    {
+	      req = "";
+	    }
 	}
     }
@@ -1062,9 +1306,11 @@
       // Do NOT (re)set m_current_structuring_style yet
       // (as requirements may NOT exist, so this is not a package)
-      // rather do it in reach_current_package (if/when requirements is read)
+      // rather do it in use_current_package (if/when requirements is read)
       //Me.m_current_structuring_style = without_version_directory;
       build_prefix (Me.m_current_package, Me.m_current_prefix);
       build_config (Me.m_current_prefix, Me.m_current_config);
     }
+
+  return req;
 }
 
@@ -1074,82 +1320,41 @@
 {
   cmt_string s;
-  s = CmtSystem::getenv ("CMTSTRUCTURINGSTYLE");
-  if (s == "without_version_directory")
-    {
-      Me.m_current_structuring_style = without_version_directory;
-    }
-  else if (s == "with_version_directory")
-    {
-      Me.m_current_structuring_style = with_version_directory;
-    } 
-
-  CmtSystem::cmt_string_vector flags;
-  Cmt::get_cmt_flags (flags);
-  for (int i = 0; i < flags.size (); i++)
-    {
-      const cmt_string& flag = flags[i];
-      if (flag == "-without_version_directory")
+  if (Me.m_current_structuring_style == default_structuring_style)
+    {
+      s = CmtSystem::getenv ("CMTSTRUCTURINGSTYLE");
+      if (s == "without_version_directory")
 	{
 	  Me.m_current_structuring_style = without_version_directory;
 	}
-      else if (flag == "-with_version_directory")
+      else if (s == "with_version_directory")
 	{
 	  Me.m_current_structuring_style = with_version_directory;
-	} 
-    }
-
-  for (int i = 1; i < ap.argc; i++)
-    {
-      const cmt_string& arg = ap.argv[i];
-      if (arg[0] != '-') break;
-      if (arg == "-without_v" ||
-	  arg == "-without_ve" ||
-	  arg == "-without_ver" ||
-	  arg == "-without_vers" ||
-	  arg == "-without_versi" ||
-	  arg == "-without_versio" ||
-	  arg == "-without_version" ||
-	  arg == "-without_version_" ||
-	  arg == "-without_version_d" ||
-	  arg == "-without_version_di" ||
-	  arg == "-without_version_dir" ||
-	  arg == "-without_version_dire" ||
-	  arg == "-without_version_direc" ||
-	  arg == "-without_version_direct" ||
-	  arg == "-without_version_directo" ||
-	  arg == "-without_version_director" ||
-	  arg == "-without_version_directory")
-	{
-	  Me.m_current_structuring_style = without_version_directory;
-	  //	  if (!CmtSystem::putenv ("CMTSTRUCTURINGSTYLE", "without_version_directory"))
-	  //	    CmtMessage::error ("Cannot set `CMTSTRUCTURINGSTYLE' to"
-	  //			       " `without_version_directory' in the environment");
-	  if (!Cmt::add_cmt_flag ("-without_version_directory"))
-	    CmtMessage::error ("Cannot add flag `-without_version_directory'");
-	}
-      else if (arg == "-with_v" ||
-	       arg == "-with_ve" ||
-	       arg == "-with_ver" ||
-	       arg == "-with_vers" ||
-	       arg == "-with_versi" ||
-	       arg == "-with_versio" ||
-	       arg == "-with_version" ||
-	       arg == "-with_version_" ||
-	       arg == "-with_version_d" ||
-	       arg == "-with_version_di" ||
-	       arg == "-with_version_dir" ||
-	       arg == "-with_version_dire" ||
-	       arg == "-with_version_direc" ||
-	       arg == "-with_version_direct" ||
-	       arg == "-with_version_directo" ||
-	       arg == "-with_version_director" ||
-	       arg == "-with_version_directory")
-	{
-	  Me.m_current_structuring_style = with_version_directory;
-	  //	  if (!CmtSystem::putenv ("CMTSTRUCTURINGSTYLE", "with_version_directory"))
-	  //	    CmtMessage::error ("Cannot set `CMTSTRUCTURINGSTYLE' to"
-	  //			       " `with_version_directory' in the environment");
-	  if (!Cmt::add_cmt_flag ("-with_version_directory"))
-	    CmtMessage::error ("Cannot add flag `-with_version_directory'");
+	}
+      
+      CmtSystem::cmt_string_vector flags;
+      Cmt::get_cmt_flags (flags);
+      for (int i = 0; i < flags.size (); i++)
+	{
+	  const cmt_string& flag = flags[i];
+	  if (flag == "-without_version_directory")
+	    {
+	      Me.m_current_structuring_style = without_version_directory;
+	    }
+	  else if (flag == "-with_version_directory")
+	    {
+	      Me.m_current_structuring_style = with_version_directory;
+	    } 
+	}
+    }
+  
+  if (Me.m_current_structuring_style != default_structuring_style)
+    {
+      StrategyDef* def = StrategyMgr::find_strategy ("VersionDirectory");
+      if (def != 0)
+	{
+	  def->m_default_value =
+	    Me.m_current_structuring_style == with_version_directory;
+	  def->m_priority_value =
+	    Me.m_current_structuring_style == without_version_directory;
 	}
     }
@@ -1171,15 +1376,16 @@
 void Cmt::configure_home (Use* use)
 {
-  Me.m_cmt_home = "";
-
-  Symbol* symbol = Symbol::find ("CMTHOME");
-  if (symbol != 0)
-    {
-      Me.m_cmt_home = symbol->build_macro_value ();
-      Symbol::expand (Me.m_cmt_home);
-    }
-  else if (CmtSystem::testenv ("CMTHOME"))
-    {
-      Me.m_cmt_home = CmtSystem::getenv ("CMTHOME");
+  if (Me.m_cmt_home.size () == 0)
+    {
+      // if not passed on the command line
+      if (const Symbol* symbol = Symbol::find ("CMTHOME"))
+	{
+	  Me.m_cmt_home = symbol->build_macro_value ();
+	  Symbol::expand (Me.m_cmt_home);
+	}
+      else if (CmtSystem::testenv ("CMTHOME"))
+	{
+	  Me.m_cmt_home = CmtSystem::getenv ("CMTHOME");
+	}
     }
 
@@ -1195,15 +1401,16 @@
 void Cmt::configure_user_context (Use* use)
 {
-  Me.m_cmt_user_context = "";
-
-  Symbol* symbol = Symbol::find ("CMTUSERCONTEXT");
-  if (symbol != 0)
-    {
-      Me.m_cmt_user_context = symbol->build_macro_value ();
-      Symbol::expand (Me.m_cmt_user_context);
-    }
-  else if (CmtSystem::testenv ("CMTUSERCONTEXT"))
-    {
-      Me.m_cmt_user_context = CmtSystem::getenv ("CMTUSERCONTEXT");
+  if (Me.m_cmt_user_context.size () == 0)
+    {
+      // if not passed on the command line
+      if (const Symbol* symbol = Symbol::find ("CMTUSERCONTEXT"))
+	{
+	  Me.m_cmt_user_context = symbol->build_macro_value ();
+	  Symbol::expand (Me.m_cmt_user_context);
+	}
+      else if (CmtSystem::testenv ("CMTUSERCONTEXT"))
+	{
+	  Me.m_cmt_user_context = CmtSystem::getenv ("CMTUSERCONTEXT");
+	}
     }
 
@@ -1272,4 +1479,44 @@
 
   Cmt::configure_tags (use);
+
+  cmt_string s, t;
+  if (0 < Me.m_extra_tags.size ())
+    {
+      s = "CMTEXTRATAGS";
+      t = use != 0 ? use->get_package_name () : s;
+    }
+  for (int i = 0; i < Me.m_extra_tags.size (); i++)
+    {
+      Tag* tag = Tag::add (Me.m_extra_tags[i], PriorityUserTag, s, use);
+      tag->mark (t);
+    }
+
+  for (int i = 0; i < Me.m_tags.size (); i++)
+    {
+      const cmt_string& a = Me.m_tags[i];
+      if (i == 0)
+	{
+	  Me.m_current_tag = a;
+	}
+//       // Then restore uname if the specified tag is CMTCONFIG
+//       if (a == CmtSystem::get_cmt_config ())
+// 	{
+// 	  Cmt::configure_uname_tag ();
+// 	}
+      Tag* tag = Tag::add (a, PriorityArgument, "arguments", 0);
+      tag->mark ("arguments");
+    }
+
+  for (int i = 0; i < Me.m_tags_add.size (); i++)
+    {
+      const cmt_string& a = Me.m_tags_add[i];
+//       // Then restore uname if the specified tag is CMTCONFIG
+//       if (a == CmtSystem::get_cmt_config ())
+// 	{
+// 	  Cmt::configure_uname_tag ();
+// 	}
+      Tag* tag = Tag::add (a, PriorityUserTag, "arguments", 0);
+      tag->mark ("arguments");
+    }
 
   /*
@@ -1277,4 +1524,5 @@
   */
 
+  /*
   if (CmtSystem::testenv ("CMTEXTRATAGS"))
     {
@@ -1309,4 +1557,5 @@
         }
     }
+  */
 }
 
@@ -1319,4 +1568,6 @@
 
   log << "current_tag=" << Me.m_current_tag << log_endl;
+
+  cmt_string s = "CMTCONFIG";
 
   Symbol* symbol = Symbol::find ("CMTCONFIG");
@@ -1347,4 +1598,5 @@
     {
       config_tag = CmtSystem::getenv ("CMTBIN");
+      s = "CMTBIN";
     }
 
@@ -1352,9 +1604,10 @@
     {
       CmtSystem::get_uname (config_tag);
+      s = "uname";
     }
 
   log << "current_tag=" << Me.m_current_tag << log_endl;
 
-  cmt_string s = "CMTCONFIG";
+  //  cmt_string s = "CMTCONFIG";
   cmt_string t = s;
 
@@ -1552,71 +1805,4 @@
 	  if (CmtMessage::level () != Warning)
 	    CmtMessage::set_level (Warning);
-	  //	  if (CmtMessage::level () > Warning)
-	}
-    }
-
-  for (int i = 1; i < ap.argc; i++)
-    {
-      const cmt_string& arg = ap.argv[i];
-      if (arg[0] != '-') break;
-      if (arg == "-d" ||
-	  arg == "-di" ||
-	  arg == "-dis" ||
-	  arg == "-disa" ||
-	  arg == "-disab" ||
-	  arg == "-disabl" ||
-	  arg == "-disable" ||
-	  arg == "-disable_" ||
-	  arg == "-disable_w" ||
-	  arg == "-disable_wa" ||
-	  arg == "-disable_war" ||
-	  arg == "-disable_warn" ||
-	  arg == "-disable_warni" ||
-	  arg == "-disable_warnin" ||
-	  arg == "-disable_warning" ||
-	  arg == "-disable_warnings")
-	{
-	  Me.m_disable_warnings = true;
-	  if (CmtMessage::level () <= Warning)
-	    {
-	      CmtMessage::set_level (Error);
-	      //	      if (!CmtSystem::putenv ("CMTERROR", "1"))
-	      //		CmtMessage::error ("Cannot set `CMTERROR' in the environment");
-	    }
-	  if (!Cmt::add_cmt_flag ("-disable_warnings"))
-	    CmtMessage::error ("Cannot add flag `-disable_warnings'");
-	}
-      else if (arg == "-q" ||
-	       arg == "-qu" ||
-	       arg == "-qui" ||
-	       arg == "-quie" ||
-	       arg == "-quiet")
-	{
-	  Me.m_quiet = true;
-	  if (CmtMessage::level () <= Error)
-	    {
-	      CmtMessage::set_level (Fatal);
-	      //	      if (!CmtSystem::putenv ("CMTFATAL", "1"))
-	      //		CmtMessage::error ("Cannot set `CMTFATAL' in the environment");
-	    }
-	  if (!Cmt::add_cmt_flag ("-quiet"))
-	    CmtMessage::error ("Cannot add flag `-quiet'");
-	}
-      else if (arg == "-warn" ||
-	       arg == "-warni" ||
-	       arg == "-warnin" ||
-	       arg == "-warning" ||
-	       arg == "-warnings")
-	{
-	  Me.m_warnings = true;
-	  //	  if (CmtMessage::level () > Warning)
-	  if (CmtMessage::level () != Warning)
-	    {
-	      CmtMessage::set_level (Warning);
-	      //	      if (!CmtSystem::putenv ("CMTWARNING", "1"))
-	      //		CmtMessage::error ("Cannot set `CMTWARNING' in the environment");
-	    }
-	  if (!Cmt::add_cmt_flag ("-warnings"))
-	    CmtMessage::error ("Cannot add flag `-warnings'");
 	}
     }
@@ -1668,7 +1854,10 @@
 
   CmtSystem::cmt_string_vector uses;
+  cmt_vector<int> use_indexes;
   CmtSystem::cmt_string_vector packages;
   CmtSystem::cmt_string_vector versions;
-  CmtSystem::cmt_string_vector path_selections;
+  Project::ConstProjectPtrVector path_selections;
+  //  CmtSystem::cmt_string_vector path_selections;
+  Project::ConstProjectPtrVector path_exclusions;
   CmtSystem::cmt_string_vector selections;
   CmtSystem::cmt_string_vector exclusions;
@@ -1677,11 +1866,11 @@
   bool is_cmt = false;
   int first = 0;
-  int i;
   bool ignore_errors = false;
   bool all_packages = false;
-
+  int depth (1);
   bool local = true;
-
-  for (i = 0; i < ap.arguments.size (); i++)
+  bool global (false);
+
+  for (int i = 0; i < ap.arguments.size (); i++)
     {
       const cmt_string& w = ap.arguments[i];
@@ -1699,12 +1888,49 @@
             {
               local = false;
+              global = false;
 
               cmt_string depth_str;
-              int depth_value = 0;
+              int depth_value;
                           
               w.substr (7, depth_str);
-              if ((sscanf (depth_str.c_str (), "%d", &depth_value) < 1) ||
-                  (depth_value < 1))
-                {
+              int n = sscanf (depth_str.c_str (), "%d", &depth_value);
+	      cmt_string msg;
+	      switch (n)
+		{
+		case EOF:
+		  msg = "Cannot read `depth' value `";
+		  msg += depth_str;
+		  msg += cmt_string ("'");
+		  if (errno)
+		    msg += cmt_string (strerror (errno));
+		  CmtError::set (CmtError::system_error, msg);
+		  return;
+		  break;
+		case 0:
+		  msg = "Invalid `depth' value `";
+		  msg += depth_str;
+		  msg += cmt_string ("'");
+		  CmtError::set (CmtError::syntax_error, msg);
+		  return;
+		  break;
+		case 1:
+		  if (depth_value < -1)
+		    {
+		      char num[32]; sprintf (num, "%lu", -depth_value);
+		      msg = "Invalid `depth' value `-";
+		      msg += num;
+		      msg += cmt_string ("'");
+		      CmtError::set (CmtError::syntax_error, msg);
+		      return;
+		    }
+		  depth = depth_value;
+		  //cerr << "depth: " << depth << endl;
+		  break;
+		default:
+		  break;
+		}
+//               if ((sscanf (depth_str.c_str (), "%d", &depth_value) < 1) ||
+//                   (depth_value < 1))
+//                {
                   // Syntax error
                   //  We shall restrict to packages found within 
@@ -1712,7 +1938,7 @@
                   //  If CMTPATH is empty, nothing is selected.
                   // depth=1 is equivalent to local
-                }
-
-	      Project::fill_selection (depth_value, path_selections);
+//                }
+
+//	      Project::fill_selection (depth_value, path_selections);
             }
           else if (w.substr (0, 9) == "-exclude=")
@@ -1738,6 +1964,6 @@
           else if (w.substr (0, 7) == "-global")
             {
-              path_selections.clear ();
-
+              //path_selections.clear ();
+	      global = true;
               local = false;
             }
@@ -1745,4 +1971,5 @@
             {
               local = true;
+	      global = false;
             }
           else if (w.substr (0, 8) == "-select=")
@@ -1787,7 +2014,33 @@
     }
 
-  if (local)
-    {
-      Project::fill_selection (1, path_selections);
+  const Project* p_cur (Project::get_current ());
+  if (global)
+    {
+      Project::fill_exclusion (path_exclusions);
+    }
+  else if (local)
+    {
+      if (p_cur)
+	Project::fill_selection (1, path_selections);
+      else
+ 	path_selections.push_back (0); // means that we want Use::current ()
+      //	path_selections.push_back ((Use::current ()).get_realpath ());
+    }
+  else
+    {
+      if (!p_cur
+	  && depth != 0
+	  && depth != -1)
+ 	path_selections.push_back (0); // means that we want Use::current ()
+// 	path_selections.push_back ((Use::current ()).get_realpath ());
+      Project::fill_selection (depth, path_selections);
+      /*
+      cerr << "depth: " << depth << endl;
+      for (int j = 0; j < path_selections.size (); j++)
+	{
+	  const Project* sp = path_selections[j];
+	  cerr << "path_selections: " << (sp ? sp->get_cmtpath () : "current use") << endl;
+	}
+      */
     }
 
@@ -1800,5 +2053,5 @@
   //if (command.substr (0, 3) == "cmt") is_cmt = true;
 
-  cmt_string curuse = CmtSystem::pwd ();
+  //cmt_string curuse = CmtSystem::pwd ();
   if (all_packages)
     {
@@ -1806,8 +2059,9 @@
       PathScanner scanner;
       Project::scan_paths (scanner, selector);
+      return;
     }
   else
     {
-      for (i = Uses.size () - 1; i >= 0; i--)
+      for (int i = Uses.size () - 1; i >= 0; i--)
         {
           Use* use = Uses[i];
@@ -1815,61 +2069,73 @@
           if (use->discarded) continue;
           if (use->m_hidden) continue;
-
           if (!use->located ())
             {
-	      CmtMessage::warning ("package " + use->get_package_name ()
-				   + " " + use->version + " " + use->path
-				   + " not found");
-	      /*
-              if (!Me.m_quiet)
-                {
-                  cerr << "#CMT> package " << use->get_package_name () <<
-		    " " << use->version << " " << use->path <<
-		    " not found" <<
-		    endl;
-                }
-	      */
+	      CmtMessage::warning
+		(CmtError::get_error_name (CmtError::package_not_found)
+		 + ": " + use->get_info ());
+	      continue;
             }
-          else
-            {
-              if (use->get_package_name () != "CMT")
-                {
-                  cmt_string& s = uses.add ();
-
-                  use->get_full_path (s);
-
-                  s += CmtSystem::file_separator ();
-                  if (use->style == mgr_style) s += "mgr";
-                  else s += "cmt";
-
-                  cmt_string& v = versions.add ();
-		  v = use->version;
-
-                  cmt_string& p = packages.add ();
-		  p = use->get_package_name ();
-                }
-            }
-        }
+	  if (use->get_package_name () == "CMT") continue;
+
+	  cmt_string& s = uses.add ();
+	  use->get_full_path (s);
+	  switch (use->style)
+	    {
+	    case cmt_style:
+	      s += CmtSystem::file_separator ();
+	      s += "cmt";
+	      break;
+	    case mgr_style:
+	      s += CmtSystem::file_separator ();
+	      s += "mgr";
+	      break;
+	    default:
+	      break;
+	    }
+//                   if (use->style == mgr_style) s += "mgr";
+//                   else s += "cmt";
+
+	  cmt_string& v = versions.add ();
+	  v = use->version;
+	  
+	  cmt_string& p = packages.add ();
+	  p = use->get_package_name ();
+	  
+	  int& use_index = use_indexes.add ();
+	  use_index = i;
+	}
           
       {
+        Use* use = &(Use::current ());
+	
         cmt_string& s = uses.add ();
+	use->get_full_path (s);
+	switch (use->style)
+	  {
+	  case cmt_style:
+	    s += CmtSystem::file_separator ();
+	    s += "cmt";
+	    break;
+	  case mgr_style:
+	    s += CmtSystem::file_separator ();
+	    s += "mgr";
+	    break;
+	  default:
+	    break;
+	  }
+//         if (use->get_package_name ().find ("cmt_standalone") != cmt_string::npos)
+//           {
+//             s = CmtSystem::pwd ();
+//           }
+//         else
+//           {
+//             use->get_full_path (s);
+
+//             s += CmtSystem::file_separator ();
                   
-        Use* use = &(Use::current ());
-
-        if (use->get_package_name ().find ("cmt_standalone") != cmt_string::npos)
-          {
-            s = CmtSystem::pwd ();
-          }
-        else
-          {
-            use->get_full_path (s);
-
-            s += CmtSystem::file_separator ();
-                  
-            if (use->style == mgr_style) s += "mgr";
-            else s += "cmt";
-          }
-
-	curuse = s;
+//             if (use->style == mgr_style) s += "mgr";
+//             else s += "cmt";
+//           }
+	//curuse = s;
 
 	cmt_string& v = versions.add ();
@@ -1878,4 +2144,7 @@
 	cmt_string& p = packages.add ();
 	p = use->get_package_name ();
+	  
+	int& use_index = use_indexes.add ();
+	use_index = -1;
       }
     }
